searchNodes=[{"doc":"Prompt provides a complete solution for building interactive command line applications. It's very flexible and can be used just to provide helpers for taking input from the user and displaying output. Basic Usage import Prompt includes utilities for: printing to the screen -&gt; display/1 printing tables to the screen -&gt; table/1 asking for confirmation -&gt; confirm/1 picking from a list of choices -&gt; select/2 asking for passwords -&gt; password/1 free form text input -&gt; text/1 Advanced usage To build a more advanced terminal application including sub-commands, define a module and use Prompt, otp_app: :your_app then build a keyword list of Prompt.Command that represents your commands and arguments and pass them to process/2 . Doing this will give you the following options out of the box: --version will pull your app version from mix.exs --help will print your @moduledoc for help. Example defmodule MyApp.CLI do @moduledoc &quot;This will print when a user types `myapp --help` in the commandline&quot; use Prompt , otp_app : :my_app # the entry point to your app, takes the command line args def main ( argv ) , do : argv |&gt; process ( first : MyApp.CLI.FirstCommand ) end end # a command defmodule MyApp.CLI.FirstCommand do @moduledoc &quot;This prints when the help() command is called&quot; use Prompt.Command @impl true def init ( argv ) do argv |&gt; OptionParser . parse ( strict : [ help : :boolean , switch1 : :boolean , swtich2 : :boolean ] , aliases : [ h : :help ] ) |&gt; parse ( ) #whatever you return from init will be what is passed to `process/1` end @impl true def process ( %{ help : true } , do : help ( ) def process ( %{ switch1 : switch1 , switch2 : switch2 } do # do something based on the command and switches display ( &quot;command output&quot; ) end defp parse ( { [ help : true ] , _ , _ } , do : %{ help : true } defp parse ( { opts , _ , _ } ) do switch1 = Keyword . get ( opts , :switch1 , false ) switch2 = Keyword . get ( opts , :switch2 , false ) %{ help : false , switch1 : switch1 , switch2 : switch2 } end end The key in the Keyword list that you pass to process/2 is what you expect the user to use as a command, the value is the Prompt.Command module that will process the command. Once built, your command will be able to take a first subcommand. &gt;&gt;&gt; my_app first --switch1 command output ... &gt;&gt;&gt; my_app --version 0.0.1 By default we try to display the @moduledoc when there is an error or when --help is passed in. This is overrideable though by implementing your own version of help/0 . Building for Distribution There are a couple of different options for building a binary ready for distributing. Which ever approach you decide to use, you'll probably want to keep the docs instead of stripping them. For escripts, you'll add the following to the escript key in mix.exs, if using Bakeware, you'll add it to the releases key. :strip_beams : [ keep : [ &quot;Docs&quot; ] ] Escript An escript is the most straightforward approach, but requires that erlang is already installed on the system. Bakeware This has been my preferred approach recently. Bakeware uses releases to build a single executable binary that can be run on the system without the dependency on erlang or elixir. For Bakeware, I also set export RELEASE_DISTRIBUTION=none in rel/env.sh.eex and rel/env.bat.eex - unless you need erlang distribution in your CLI. For a complete example see Slim","ref":"Prompt.html","title":"Prompt","type":"behaviour"},{"doc":"Display a choice prompt with custom answers. Takes a keyword list of answers in the form of atom to return and string to display. [yes: &quot;y&quot;, no: &quot;n&quot;] will show &quot;(y/n)&quot; and return :yes or :no based on the choice. Supported options: :color - The text color. One of [:black, :blue, :cyan, :green, :light_black, :light_blue, :light_cyan, :light_green, :light_magneta, :light_red, :light_white, :light_yellow, :magenta, :red, :white, :yellow] . :background_color - The background color. One of [:black, :blue, :cyan, :green, :light_black, :light_blue, :light_cyan, :light_green, :light_magneta, :light_red, :light_white, :light_yellow, :magenta, :red, :white, :yellow] . :default_answer - The default answer for the choices. Defaults to the first choice. Examples iex&gt; Prompt . choice ( &quot;Save password?&quot; , ...&gt; [ yes : &quot;y&quot; , no : &quot;n&quot; , regenerate : &quot;r&quot; ] , ...&gt; default_answer : :regenerate ...&gt; ) &quot;Save Password? (y/n/R):&quot; [ enter ] iex&gt; :regenerate","ref":"Prompt.html#choice/3","title":"Prompt.choice/3","type":"function"},{"doc":"Display a Y/n prompt. Sets 'Y' as the the default answer, allowing the user to just press the enter key. To make 'n' the default answer pass the option default_answer: :no Supported options: :color - The text color. One of [:black, :blue, :cyan, :green, :light_black, :light_blue, :light_cyan, :light_green, :light_magneta, :light_red, :light_white, :light_yellow, :magenta, :red, :white, :yellow] . :background_color - The background color. One of [:black, :blue, :cyan, :green, :light_black, :light_blue, :light_cyan, :light_green, :light_magneta, :light_red, :light_white, :light_yellow, :magenta, :red, :white, :yellow] . :default_answer - The default answer to the confirmation. The default value is :yes . :mask_line - If set to true, this will mask the current line by replacing it with ##### . Useful when showing passwords in the terminal. The default value is false . Examples iex&gt; Prompt . confirm ( &quot;Send the email?&quot; ) &quot;Send the email? (Y/n):&quot; Y iex&gt; :yes iex&gt; Prompt . confirm ( &quot;Send the email?&quot; , default_answer : :no ) &quot;Send the email? (y/N):&quot; [ enter ] iex&gt; :no","ref":"Prompt.html#confirm/2","title":"Prompt.confirm/2","type":"function"},{"doc":"Writes text to the screen. Takes a single string argument or a list of strings where each item in the list will be diplayed on a new line. Supported options: :color - The text color. One of [:black, :blue, :cyan, :green, :light_black, :light_blue, :light_cyan, :light_green, :light_magneta, :light_red, :light_white, :light_yellow, :magenta, :red, :white, :yellow] . Defaults to the terminal default. :background_color - The background color. One of [:black, :blue, :cyan, :green, :light_black, :light_blue, :light_cyan, :light_green, :light_magneta, :light_red, :light_white, :light_yellow, :magenta, :red, :white, :yellow] . Defaults to the terminal default. :position - Print the content starting from the leftmost position or the rightmost position The default value is :left . :mask_line - If set to true, this will mask the current line by replacing it with ##### . Useful when showing passwords in the terminal. The default value is false . Examples iex&gt; Prompt . display ( &quot;Hello from the terminal!&quot; ) &quot;Hello from the terminal!&quot; iex&gt; Prompt . display ( [ &quot;Hello&quot; , &quot;from&quot; , &quot;the&quot; , &quot;terminal&quot; ] ) &quot;Hello&quot; &quot;from&quot; &quot;the&quot; &quot;terminal&quot;","ref":"Prompt.html#display/2","title":"Prompt.display/2","type":"function"},{"doc":"Prints help to the screen when there is an error, or --help is passed as an argument","ref":"Prompt.html#c:help/0","title":"Prompt.help/0","type":"callback"},{"doc":"Prompt the user for input, but conceal the users typing. Supported options: :color - The text color. One of [:black, :blue, :cyan, :green, :light_black, :light_blue, :light_cyan, :light_green, :light_magneta, :light_red, :light_white, :light_yellow, :magenta, :red, :white, :yellow] . Defaults to the terminal default. :background_color - The background color. One of [:black, :blue, :cyan, :green, :light_black, :light_blue, :light_cyan, :light_green, :light_magneta, :light_red, :light_white, :light_yellow, :magenta, :red, :white, :yellow] . Defaults to the terminal default. Examples iex&gt; Prompt . password ( &quot;Enter your passsword&quot; ) &quot;Enter your password:&quot; iex&gt; &quot;super_secret_passphrase&quot;","ref":"Prompt.html#password/2","title":"Prompt.password/2","type":"function"},{"doc":"Process the command line arguments based on the defined commands","ref":"Prompt.html#c:process/2","title":"Prompt.process/2","type":"callback"},{"doc":"Displays options to the user denoted by numbers. Allows for a list of 2 tuples where the first value is what is displayed and the second value is what is returned to the caller. Supported options: :color - The text color. One of [:black, :blue, :cyan, :green, :light_black, :light_blue, :light_cyan, :light_green, :light_magneta, :light_red, :light_white, :light_yellow, :magenta, :red, :white, :yellow] . Defaults to the terminal default. :background_color - The background color. One of [:black, :blue, :cyan, :green, :light_black, :light_blue, :light_cyan, :light_green, :light_magneta, :light_red, :light_white, :light_yellow, :magenta, :red, :white, :yellow] . Defaults to the terminal default. :multi - Allows multiple selections from the options presented. The default value is false . Examples iex&gt; Prompt . select ( &quot;Choose One&quot; , [ &quot;Choice A&quot; , &quot;Choice B&quot; ] ) &quot; [1] Choice A&quot; &quot; [2] Choice B&quot; &quot;Choose One [1-2]:&quot; 1 iex&gt; &quot;Choice A&quot; iex&gt; Prompt . select ( &quot;Choose One&quot; , [ { &quot;Choice A&quot; , 1000 } , { &quot;Choice B&quot; , 1001 } ] ) &quot; [1] Choice A&quot; &quot; [2] Choice B&quot; &quot;Choose One [1-2]:&quot; 2 iex&gt; 1001 iex&gt; Prompt . select ( &quot;Choose as many as you want&quot; , [ &quot;Choice A&quot; , &quot;Choice B&quot; ] , multi : true ) &quot; [1] Choice A&quot; &quot; [2] Choice B&quot; &quot;Choose as many as you want [1-2]:&quot; 1 2 iex&gt; [ &quot;Choice A&quot; , &quot;Choice B&quot; ]","ref":"Prompt.html#select/3","title":"Prompt.select/3","type":"function"},{"doc":"Print an ASCII table of data. Requires a list of lists as input. Supported options: :header - Use the first element as the header for the table. The default value is false . :border border: :normal (default) | :markdown --- determine how the border is displayed Examples iex&gt; Prompt . table ( [ [ &quot;Hello&quot; , &quot;from&quot; , &quot;the&quot; , &quot;terminal!&quot; ] , [ &quot;this&quot; , &quot;is&quot; , &quot;another&quot; , &quot;row&quot; ] ] ) &quot; +-------+------+---------+----------+ | Hello | from | the | terminal | | this | is | another | row | +-------+------+---------+----------+ &quot; iex&gt; Prompt . table ( [ [ &quot;One&quot; , &quot;Two&quot; , &quot;Three&quot; , &quot;Four&quot; ] , [ &quot;Hello&quot; , &quot;from&quot; , &quot;the&quot; , &quot;terminal!&quot; ] , [ &quot;this&quot; , &quot;is&quot; , &quot;another&quot; , &quot;row&quot; ] ] , header : true ) &quot; +-------+------+---------+----------+ | One | Two | Three | Four | +-------+------+---------+----------+ | Hello | from | the | terminal | | this | is | another | row | +-------+------+---------+----------+ &quot; iex&gt; Prompt . table ( [ [ &quot;One&quot; , &quot;Two&quot; , &quot;Three&quot; , &quot;Four&quot; ] , [ &quot;Hello&quot; , &quot;from&quot; , &quot;the&quot; , &quot;terminal!&quot; ] , [ &quot;this&quot; , &quot;is&quot; , &quot;another&quot; , &quot;row&quot; ] ] , header : true , border : :markdown ) &quot; | One | Two | Three | Four | |-------|------|---------|----------| | Hello | from | the | terminal | | this | is | another | row | &quot;","ref":"Prompt.html#table/2","title":"Prompt.table/2","type":"function"},{"doc":"Use this to get an iolist back of the table. Useful when you want an ascii table/1 for other mediums like markdown files.","ref":"Prompt.html#table_data/2","title":"Prompt.table_data/2","type":"function"},{"doc":"Display text on the screen and wait for the users text imput. Supported options: :color - The text color. One of [:black, :blue, :cyan, :green, :light_black, :light_blue, :light_cyan, :light_green, :light_magneta, :light_red, :light_white, :light_yellow, :magenta, :red, :white, :yellow] . Defaults to the terminal default. :background_color - The background color. One of [:black, :blue, :cyan, :green, :light_black, :light_blue, :light_cyan, :light_green, :light_magneta, :light_red, :light_white, :light_yellow, :magenta, :red, :white, :yellow] . Defaults to the terminal default. Examples iex&gt; Prompt . text ( &quot;Enter your email&quot; ) &quot;Enter your email:&quot; t @t . com iex&gt; t @t . com","ref":"Prompt.html#text/2","title":"Prompt.text/2","type":"function"},{"doc":"The list of strings coming from the commmand-line arguments","ref":"Prompt.html#t:argv/0","title":"Prompt.argv/0","type":"type"},{"doc":"A keyword list of commands and implementations of Prompt.Command Examples iex&gt; commands = [ help : CLI.Commands.Help , version : CLI.Commands.Version ]","ref":"Prompt.html#t:command_list/0","title":"Prompt.command_list/0","type":"type"},{"doc":"Helps users define and build command line commands. Defines the behaviour for a Command. We expect init/1 to be called with the command line options and get back a data structure that is passed to process/1 which handles all of the side effects of the command itself. Example defmodule MyCommand do @moduledoc &quot;MyCommand&#39;s help message help() is defined in the __using__ macro that prints this message if called&quot; use Prompt.Command @impl true def init ( _argv ) do # parse list of args to map or struct %{ list : true , help : false , directory : &quot;path/to/dir&quot; } end @impl true def process ( %{ help : true } ) , do : help ( ) # this help function is defined by default in the macro that prints the @moduledoc when called def process ( %{ list : true , help : false , directory : dir } ) do display ( File . ls! ( dir ) ) end end Typically one will use the OptionParser.parse/1 function to parse the command defp parse ( argv ) do argv |&gt; OptionParser . parse ( strict : [ help : :boolean , directory : :string , list : :boolean ] , aliases : [ h : :help , d : :directory ] ) |&gt; _parse ( ) end defp _parse ( { opts , _ , _ } ) do help = Keyword . get ( opts , :help , false ) dir = Keyword . get ( opts , :directory , &quot;./&quot; ) list = Keyword . get ( opts , :length , true ) %{ help : help , directory : dir , list : list } end If this is used in a release, help() won't print the @moduledoc correctly because releases strip documentation by default. For this to work correctly, tell the release to keep docs: releases : [ appname : [ strip_beams : [ keep : [ &quot;Docs&quot; ] ] ] ]","ref":"Prompt.Command.html","title":"Prompt.Command","type":"behaviour"},{"doc":"Prints the help available for this command","ref":"Prompt.Command.html#c:help/0","title":"Prompt.Command.help/0","type":"callback"},{"doc":"Takes the options passed in via the command line and tramforms them into a struct that the process command can handle","ref":"Prompt.Command.html#c:init/1","title":"Prompt.Command.init/1","type":"callback"},{"doc":"Processes the command and does the things required","ref":"Prompt.Command.html#c:process/1","title":"Prompt.Command.process/1","type":"callback"},{"doc":"Manipulate the position of the cursor and the display of previous text.","ref":"Prompt.Position.html","title":"Prompt.Position","type":"module"},{"doc":"Clears the content from the previous number of lines and resets the cursor.","ref":"Prompt.Position.html#clear_lines/1","title":"Prompt.Position.clear_lines/1","type":"function"},{"doc":"Mask the content on the terminal relative_line above. By default will clear the line and put ####### in its place then move the cursor back to the current line.","ref":"Prompt.Position.html#mask_line/1","title":"Prompt.Position.mask_line/1","type":"function"},{"doc":"Terminal UI Library for Elixir Motivation Installation Basic Usage Display text on the screen Ask the user for input Ask the user for a password Ask the user for confirmation Custom confirmation choices List of selections Tables Advanced Usage Example Application","ref":"introduction.html","title":"Introduction","type":"extras"},{"doc":"To create a really great development experience and API for Elixir developers that want to build commandline tools.","ref":"introduction.html#motivation","title":"Introduction - Motivation","type":"extras"},{"doc":"Add prompt to your list of dependencies in mix.exs : def deps do [ { :prompt , &quot;~&gt; 0.5&quot; } ] end Read the official documentation","ref":"introduction.html#installation","title":"Introduction - Installation","type":"extras"},{"doc":"All of the following commands take a keyword list of options for things like text color and positioning. Display text on the screen Prompt.display/2 Prompt . display ( &quot;Hello, world!&quot; ) Ask the user for input Prompt.text/2 Useful for prompting the user to enter freeform text Prompt . text ( &quot;Enter info here&quot; ) Will display: &gt; Enter info here: and wait for the user to enter text Ask the user for a password Prompt.password/2 When you need to hide the input that the user types Prompt . password ( &quot;Enter password&quot; ) Ask the user for confirmation Prompt.confirm/2 Prompt . confirm ( &quot;Are you sure?&quot; ) Will display: &gt; Are you sure? (Y/n): and will allow the user to just press [enter] to confirm If you'd prefer n to be the default pass the default_answer option Prompt . confirm ( &quot;Are you sure?&quot; , default_answer : :no ) Returns :yes or :no based on the answer Custom confirmation choices Prompt.choice/2 Sometimes yes/no aren't the only choices a user can make, this method allows you to pass any choices as the confirmation. Prompt . choice ( &quot;Accept, Reload or Cancel&quot; , accept : &quot;a&quot; , reload : &quot;r&quot; , cancel : &quot;c&quot; ) displays &gt; Accept, Reload or Cancel (A/r/c): Returns the key of the answer i.e :accept , :reload or cancel in this exammple List of selections Prompt.select/2 To show the user a list of options to select from Prompt . select ( &quot;Choose a protocol&quot; , [ &quot;file://&quot; , &quot;ssh://&quot; , &quot;ftp://&quot; ] ) Displays: [1] file:// [2] ssh:// [3] ftp:// &gt; Choose a protocol [1-3]: and returns a string of their choice Tables Prompt.table/2 To show a table of data Prompt . table ( [ [ &quot;Hello&quot; , &quot;from&quot; , &quot;the&quot; , &quot;terminal!&quot; ] , [ &quot;this&quot; , &quot;is&quot; , &quot;another&quot; , &quot;row&quot; ] ] ) Will display &gt; +-------+------+---------+----------+ | Hello | from | the | terminal | | this | is | another | row | +-------+------+---------+----------+","ref":"introduction.html#basic-usage","title":"Introduction - Basic Usage","type":"extras"},{"doc":"To use the more advanced features, see the official documentation","ref":"introduction.html#advanced-usage-with-subcommands","title":"Introduction - Advanced Usage with Subcommands","type":"extras"},{"doc":"For a complete example, take a look at Slim - a cherry-picking tool","ref":"introduction.html#example","title":"Introduction - Example","type":"extras"},{"doc":"","ref":"example.html","title":"Example","type":"extras"},{"doc":"Lets go through an example of creating and building a new commandline/terminal app with Prompt that will acknowledge a person. Lets call it ack . Start by creating a new mix project mix new ack . And then including prompt as a dependency (here we use Mix.install/1 but you can do this in mix.exs dependency section). Mix . install ( prompt : &quot;~&gt; 0.6&quot; )","ref":"example.html#starting-out","title":"Example - Starting Out","type":"extras"},{"doc":"Lets start by defining our first command. We'll call it Hello and have it say hello to the name passed in. $ ack hello friend will respond with Hello friend To do this, we'll need to use Prompt.Command and implement some callbacks: init/1 - tkes any arguments passed after the command i.e if you call ack hello user -j --print , you'll receive an array of [&quot;user&quot;, &quot;-j&quot;, &quot;--print&quot;] as the parameter to init for the hello command process/1 - whatever you return from init/1 will be the input to this function defmodule Command.Hello do @moduledoc &quot;&quot;&quot; The help message cmd &lt;name&gt; --help prints this help message &quot;&quot;&quot; use Prompt.Command @impl true def init ( argv ) do # lets use OptionParser.parse/2 to parse the # options and arguments passed to the subcommand argv |&gt; OptionParser . parse ( strict : [ help : :boolean ] , aliases : [ h : :help ] ) |&gt; parse ( ) end @impl true def process ( %{ help : true } ) , do : help ( ) def process ( %{ name : name } ) , do : display ( &quot;Hello \#{ name } &quot; , color : IO.ANSI . green ( ) ) # name was not passed in defp parse ( { _ , [ ] , _ } ) , do : %{ help : true } # help was passed in defp parse ( { [ help : true ] , _ , _ } ) , do : %{ help : true } # name was passed in defp parse ( { _ , [ name | _ ] , _ } ) , do : %{ name : name } end","ref":"example.html#build-our-first-subcommand","title":"Example - Build our first  subcommand","type":"extras"},{"doc":"Now that we defined a subcommand, we need a 'main' module that can take all commandline args and options and 'route' them to the correct place. Lets define a CLI module and create a main function where we can use Prompt to pull in the Prompt behaviour. defmodule CLI do @moduledoc &quot;&quot;&quot; DOCUMENTATION FOR THE TOOL &quot;&quot;&quot; use Prompt , otp_app : :ack @doc &quot;The entry point for the application&quot; def main ( argv ) do # define the subcommands and which module handles them subcommands = [ hello : Command.Hello ] # now use the provided `process/2` function process ( argv , subcommands ) end end","ref":"example.html#the-entry-point","title":"Example - The Entry Point","type":"extras"},{"doc":"We'll have to simulate calling the command in this notebook by passing a list of flags to CLI.main/1 . CLI . main ( [ &quot;hello&quot; , IO . gets ( &quot;input&quot; ) ] )","ref":"example.html#call-your-new-command","title":"Example - Call your new Command","type":"extras"},{"doc":"To build your app, you'll need to decide if you want an escript of a binary. The former will require the user of your tool to have Elixir and Erlang installed on their system. A binary built using Bakeware can be distributed and used without having Elixir or Erlang on the system. See the documentation for details on both","ref":"example.html#bundle-and-distribute","title":"Example - Bundle and Distribute","type":"extras"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - Unreleased","type":"extras"},{"doc":"Added use NimbleOptions to validate options background_color as an option for displaying text Changed modified the way to pass in text color takes an atom now instead of an IO.ANSI color function refactored select/2 into it's own module refactored choice/2 into it's own module refactored confirm/2 into it's own module refactored text/2 into it's own module","ref":"changelog.html#0-6-3-2021-11-28","title":"Changelog - 0.6.3 - 2021-11-28","type":"extras"},{"doc":"Documentation Added Livebook example as extra pages in hexdoc Organized Prompt functions as Input / Output Nested Modules for better readability Updated ex_docs Added GPL License file","ref":"changelog.html#0-6-2-2021-10-25","title":"Changelog - 0.6.2 - 2021-10-25","type":"extras"},{"doc":"Added Many more tests","ref":"changelog.html#0-6-1-2021-10-21","title":"Changelog - 0.6.1 - 2021-10-21","type":"extras"},{"doc":"","ref":"changelog.html#livebook-notebook-with-an-example","title":"Changelog - Livebook notebook with an example","type":"extras"},{"doc":"Added a help/0 callback and the ability to override Changed Instead of taking a list of tuples for commands ( [{&quot;command&quot;, Module&quot;}] ), now take a Keyword list ( [command: Module] )","ref":"changelog.html#0-6-0-2021-10-17","title":"Changelog - 0.6.0 - 2021-10-17","type":"extras"},{"doc":"GNU GENERAL PUBLIC LICENSE Version 3, 29 June 2007 Copyright (C) 2007 Free Software Foundation, Inc. &lt;https://fsf.org/&gt; Everyone is permitted to copy and distribute verbatim copies of this license document, but changing it is not allowed. Preamble The GNU General Public License is a free, copyleft license for software and other kinds of works. The licenses for most software and other practical works are designed to take away your freedom to share and change the works. By contrast, the GNU General Public License is intended to guarantee your freedom to share and change all versions of a program--to make sure it remains free software for all its users. We, the Free Software Foundation, use the GNU General Public License for most of our software; it applies also to any other work released this way by its authors. You can apply it to your programs, too. When we speak of free software, we are referring to freedom, not price. Our General Public Licenses are designed to make sure that you have the freedom to distribute copies of free software (and charge for them if you wish), that you receive source code or can get it if you want it, that you can change the software or use pieces of it in new free programs, and that you know you can do these things. To protect your rights, we need to prevent others from denying you these rights or asking you to surrender the rights. Therefore, you have certain responsibilities if you distribute copies of the software, or if you modify it: responsibilities to respect the freedom of others. For example, if you distribute copies of such a program, whether gratis or for a fee, you must pass on to the recipients the same freedoms that you received. You must make sure that they, too, receive or can get the source code. And you must show them these terms so they know their rights. Developers that use the GNU GPL protect your rights with two steps: (1) assert copyright on the software, and (2) offer you this License giving you legal permission to copy, distribute and/or modify it. For the developers' and authors' protection, the GPL clearly explains that there is no warranty for this free software. For both users' and authors' sake, the GPL requires that modified versions be marked as changed, so that their problems will not be attributed erroneously to authors of previous versions. Some devices are designed to deny users access to install or run modified versions of the software inside them, although the manufacturer can do so. This is fundamentally incompatible with the aim of protecting users' freedom to change the software. The systematic pattern of such abuse occurs in the area of products for individuals to use, which is precisely where it is most unacceptable. Therefore, we have designed this version of the GPL to prohibit the practice for those products. If such problems arise substantially in other domains, we stand ready to extend this provision to those domains in future versions of the GPL, as needed to protect the freedom of users. Finally, every program is threatened constantly by software patents. States should not allow patents to restrict development and use of software on general-purpose computers, but in those that do, we wish to avoid the special danger that patents applied to a free program could make it effectively proprietary. To prevent this, the GPL assures that patents cannot be used to render the program non-free. The precise terms and conditions for copying, distribution and modification follow. TERMS AND CONDITIONS 0. Definitions. &quot;This License&quot; refers to version 3 of the GNU General Public License. &quot;Copyright&quot; also means copyright-like laws that apply to other kinds of works, such as semiconductor masks. &quot;The Program&quot; refers to any copyrightable work licensed under this License. Each licensee is addressed as &quot;you&quot;. &quot;Licensees&quot; and &quot;recipients&quot; may be individuals or organizations. To &quot;modify&quot; a work means to copy from or adapt all or part of the work in a fashion requiring copyright permission, other than the making of an exact copy. The resulting work is called a &quot;modified version&quot; of the earlier work or a work &quot;based on&quot; the earlier work. A &quot;covered work&quot; means either the unmodified Program or a work based on the Program. To &quot;propagate&quot; a work means to do anything with it that, without permission, would make you directly or secondarily liable for infringement under applicable copyright law, except executing it on a computer or modifying a private copy. Propagation includes copying, distribution (with or without modification), making available to the public, and in some countries other activities as well. To &quot;convey&quot; a work means any kind of propagation that enables other parties to make or receive copies. Mere interaction with a user through a computer network, with no transfer of a copy, is not conveying. An interactive user interface displays &quot;Appropriate Legal Notices&quot; to the extent that it includes a convenient and prominently visible feature that (1) displays an appropriate copyright notice, and (2) tells the user that there is no warranty for the work (except to the extent that warranties are provided), that licensees may convey the work under this License, and how to view a copy of this License. If the interface presents a list of user commands or options, such as a menu, a prominent item in the list meets this criterion. 1. Source Code. The &quot;source code&quot; for a work means the preferred form of the work for making modifications to it. &quot;Object code&quot; means any non-source form of a work. A &quot;Standard Interface&quot; means an interface that either is an official standard defined by a recognized standards body, or, in the case of interfaces specified for a particular programming language, one that is widely used among developers working in that language. The &quot;System Libraries&quot; of an executable work include anything, other than the work as a whole, that (a) is included in the normal form of packaging a Major Component, but which is not part of that Major Component, and (b) serves only to enable use of the work with that Major Component, or to implement a Standard Interface for which an implementation is available to the public in source code form. A &quot;Major Component&quot;, in this context, means a major essential component (kernel, window system, and so on) of the specific operating system (if any) on which the executable work runs, or a compiler used to produce the work, or an object code interpreter used to run it. The &quot;Corresponding Source&quot; for a work in object code form means all the source code needed to generate, install, and (for an executable work) run the object code and to modify the work, including scripts to control those activities. However, it does not include the work's System Libraries, or general-purpose tools or generally available free programs which are used unmodified in performing those activities but which are not part of the work. For example, Corresponding Source includes interface definition files associated with source files for the work, and the source code for shared libraries and dynamically linked subprograms that the work is specifically designed to require, such as by intimate data communication or control flow between those subprograms and other parts of the work. The Corresponding Source need not include anything that users can regenerate automatically from other parts of the Corresponding Source. The Corresponding Source for a work in source code form is that same work. 2. Basic Permissions. All rights granted under this License are granted for the term of copyright on the Program, and are irrevocable provided the stated conditions are met. This License explicitly affirms your unlimited permission to run the unmodified Program. The output from running a covered work is covered by this License only if the output, given its content, constitutes a covered work. This License acknowledges your rights of fair use or other equivalent, as provided by copyright law. You may make, run and propagate covered works that you do not convey, without conditions so long as your license otherwise remains in force. You may convey covered works to others for the sole purpose of having them make modifications exclusively for you, or provide you with facilities for running those works, provided that you comply with the terms of this License in conveying all material for which you do not control copyright. Those thus making or running the covered works for you must do so exclusively on your behalf, under your direction and control, on terms that prohibit them from making any copies of your copyrighted material outside their relationship with you. Conveying under any other circumstances is permitted solely under the conditions stated below. Sublicensing is not allowed; section 10 makes it unnecessary. 3. Protecting Users' Legal Rights From Anti-Circumvention Law. No covered work shall be deemed part of an effective technological measure under any applicable law fulfilling obligations under article 11 of the WIPO copyright treaty adopted on 20 December 1996, or similar laws prohibiting or restricting circumvention of such measures. When you convey a covered work, you waive any legal power to forbid circumvention of technological measures to the extent such circumvention is effected by exercising rights under this License with respect to the covered work, and you disclaim any intention to limit operation or modification of the work as a means of enforcing, against the work's users, your or third parties' legal rights to forbid circumvention of technological measures. 4. Conveying Verbatim Copies. You may convey verbatim copies of the Program's source code as you receive it, in any medium, provided that you conspicuously and appropriately publish on each copy an appropriate copyright notice; keep intact all notices stating that this License and any non-permissive terms added in accord with section 7 apply to the code; keep intact all notices of the absence of any warranty; and give all recipients a copy of this License along with the Program. You may charge any price or no price for each copy that you convey, and you may offer support or warranty protection for a fee. 5. Conveying Modified Source Versions. You may convey a work based on the Program, or the modifications to produce it from the Program, in the form of source code under the terms of section 4, provided that you also meet all of these conditions: a) The work must carry prominent notices stating that you modified it, and giving a relevant date. b) The work must carry prominent notices stating that it is released under this License and any conditions added under section 7. This requirement modifies the requirement in section 4 to &quot;keep intact all notices&quot;. c) You must license the entire work, as a whole, under this License to anyone who comes into possession of a copy. This License will therefore apply, along with any applicable section 7 additional terms, to the whole of the work, and all its parts, regardless of how they are packaged. This License gives no permission to license the work in any other way, but it does not invalidate such permission if you have separately received it. d) If the work has interactive user interfaces, each must display Appropriate Legal Notices; however, if the Program has interactive interfaces that do not display Appropriate Legal Notices, your work need not make them do so. A compilation of a covered work with other separate and independent works, which are not by their nature extensions of the covered work, and which are not combined with it such as to form a larger program, in or on a volume of a storage or distribution medium, is called an &quot;aggregate&quot; if the compilation and its resulting copyright are not used to limit the access or legal rights of the compilation's users beyond what the individual works permit. Inclusion of a covered work in an aggregate does not cause this License to apply to the other parts of the aggregate. 6. Conveying Non-Source Forms. You may convey a covered work in object code form under the terms of sections 4 and 5, provided that you also convey the machine-readable Corresponding Source under the terms of this License, in one of these ways: a) Convey the object code in, or embodied in, a physical product (including a physical distribution medium), accompanied by the Corresponding Source fixed on a durable physical medium customarily used for software interchange. b) Convey the object code in, or embodied in, a physical product (including a physical distribution medium), accompanied by a written offer, valid for at least three years and valid for as long as you offer spare parts or customer support for that product model, to give anyone who possesses the object code either (1) a copy of the Corresponding Source for all the software in the product that is covered by this License, on a durable physical medium customarily used for software interchange, for a price no more than your reasonable cost of physically performing this conveying of source, or (2) access to copy the Corresponding Source from a network server at no charge. c) Convey individual copies of the object code with a copy of the written offer to provide the Corresponding Source. This alternative is allowed only occasionally and noncommercially, and only if you received the object code with such an offer, in accord with subsection 6b. d) Convey the object code by offering access from a designated place (gratis or for a charge), and offer equivalent access to the Corresponding Source in the same way through the same place at no further charge. You need not require recipients to copy the Corresponding Source along with the object code. If the place to copy the object code is a network server, the Corresponding Source may be on a different server (operated by you or a third party) that supports equivalent copying facilities, provided you maintain clear directions next to the object code saying where to find the Corresponding Source. Regardless of what server hosts the Corresponding Source, you remain obligated to ensure that it is available for as long as needed to satisfy these requirements. e) Convey the object code using peer-to-peer transmission, provided you inform other peers where the object code and Corresponding Source of the work are being offered to the general public at no charge under subsection 6d. A separable portion of the object code, whose source code is excluded from the Corresponding Source as a System Library, need not be included in conveying the object code work. A &quot;User Product&quot; is either (1) a &quot;consumer product&quot;, which means any tangible personal property which is normally used for personal, family, or household purposes, or (2) anything designed or sold for incorporation into a dwelling. In determining whether a product is a consumer product, doubtful cases shall be resolved in favor of coverage. For a particular product received by a particular user, &quot;normally used&quot; refers to a typical or common use of that class of product, regardless of the status of the particular user or of the way in which the particular user actually uses, or expects or is expected to use, the product. A product is a consumer product regardless of whether the product has substantial commercial, industrial or non-consumer uses, unless such uses represent the only significant mode of use of the product. &quot;Installation Information&quot; for a User Product means any methods, procedures, authorization keys, or other information required to install and execute modified versions of a covered work in that User Product from a modified version of its Corresponding Source. The information must suffice to ensure that the continued functioning of the modified object code is in no case prevented or interfered with solely because modification has been made. If you convey an object code work under this section in, or with, or specifically for use in, a User Product, and the conveying occurs as part of a transaction in which the right of possession and use of the User Product is transferred to the recipient in perpetuity or for a fixed term (regardless of how the transaction is characterized), the Corresponding Source conveyed under this section must be accompanied by the Installation Information. But this requirement does not apply if neither you nor any third party retains the ability to install modified object code on the User Product (for example, the work has been installed in ROM). The requirement to provide Installation Information does not include a requirement to continue to provide support service, warranty, or updates for a work that has been modified or installed by the recipient, or for the User Product in which it has been modified or installed. Access to a network may be denied when the modification itself materially and adversely affects the operation of the network or violates the rules and protocols for communication across the network. Corresponding Source conveyed, and Installation Information provided, in accord with this section must be in a format that is publicly documented (and with an implementation available to the public in source code form), and must require no special password or key for unpacking, reading or copying. 7. Additional Terms. &quot;Additional permissions&quot; are terms that supplement the terms of this License by making exceptions from one or more of its conditions. Additional permissions that are applicable to the entire Program shall be treated as though they were included in this License, to the extent that they are valid under applicable law. If additional permissions apply only to part of the Program, that part may be used separately under those permissions, but the entire Program remains governed by this License without regard to the additional permissions. When you convey a copy of a covered work, you may at your option remove any additional permissions from that copy, or from any part of it. (Additional permissions may be written to require their own removal in certain cases when you modify the work.) You may place additional permissions on material, added by you to a covered work, for which you have or can give appropriate copyright permission. Notwithstanding any other provision of this License, for material you add to a covered work, you may (if authorized by the copyright holders of that material) supplement the terms of this License with terms: a) Disclaiming warranty or limiting liability differently from the terms of sections 15 and 16 of this License; or b) Requiring preservation of specified reasonable legal notices or author attributions in that material or in the Appropriate Legal Notices displayed by works containing it; or c) Prohibiting misrepresentation of the origin of that material, or requiring that modified versions of such material be marked in reasonable ways as different from the original version; or d) Limiting the use for publicity purposes of names of licensors or authors of the material; or e) Declining to grant rights under trademark law for use of some trade names, trademarks, or service marks; or f) Requiring indemnification of licensors and authors of that material by anyone who conveys the material (or modified versions of it) with contractual assumptions of liability to the recipient, for any liability that these contractual assumptions directly impose on those licensors and authors. All other non-permissive additional terms are considered &quot;further restrictions&quot; within the meaning of section 10. If the Program as you received it, or any part of it, contains a notice stating that it is governed by this License along with a term that is a further restriction, you may remove that term. If a license document contains a further restriction but permits relicensing or conveying under this License, you may add to a covered work material governed by the terms of that license document, provided that the further restriction does not survive such relicensing or conveying. If you add terms to a covered work in accord with this section, you must place, in the relevant source files, a statement of the additional terms that apply to those files, or a notice indicating where to find the applicable terms. Additional terms, permissive or non-permissive, may be stated in the form of a separately written license, or stated as exceptions; the above requirements apply either way. 8. Termination. You may not propagate or modify a covered work except as expressly provided under this License. Any attempt otherwise to propagate or modify it is void, and will automatically terminate your rights under this License (including any patent licenses granted under the third paragraph of section 11). However, if you cease all violation of this License, then your license from a particular copyright holder is reinstated (a) provisionally, unless and until the copyright holder explicitly and finally terminates your license, and (b) permanently, if the copyright holder fails to notify you of the violation by some reasonable means prior to 60 days after the cessation. Moreover, your license from a particular copyright holder is reinstated permanently if the copyright holder notifies you of the violation by some reasonable means, this is the first time you have received notice of violation of this License (for any work) from that copyright holder, and you cure the violation prior to 30 days after your receipt of the notice. Termination of your rights under this section does not terminate the licenses of parties who have received copies or rights from you under this License. If your rights have been terminated and not permanently reinstated, you do not qualify to receive new licenses for the same material under section 10. 9. Acceptance Not Required for Having Copies. You are not required to accept this License in order to receive or run a copy of the Program. Ancillary propagation of a covered work occurring solely as a consequence of using peer-to-peer transmission to receive a copy likewise does not require acceptance. However, nothing other than this License grants you permission to propagate or modify any covered work. These actions infringe copyright if you do not accept this License. Therefore, by modifying or propagating a covered work, you indicate your acceptance of this License to do so. 10. Automatic Licensing of Downstream Recipients. Each time you convey a covered work, the recipient automatically receives a license from the original licensors, to run, modify and propagate that work, subject to this License. You are not responsible for enforcing compliance by third parties with this License. An &quot;entity transaction&quot; is a transaction transferring control of an organization, or substantially all assets of one, or subdividing an organization, or merging organizations. If propagation of a covered work results from an entity transaction, each party to that transaction who receives a copy of the work also receives whatever licenses to the work the party's predecessor in interest had or could give under the previous paragraph, plus a right to possession of the Corresponding Source of the work from the predecessor in interest, if the predecessor has it or can get it with reasonable efforts. You may not impose any further restrictions on the exercise of the rights granted or affirmed under this License. For example, you may not impose a license fee, royalty, or other charge for exercise of rights granted under this License, and you may not initiate litigation (including a cross-claim or counterclaim in a lawsuit) alleging that any patent claim is infringed by making, using, selling, offering for sale, or importing the Program or any portion of it. 11. Patents. A &quot;contributor&quot; is a copyright holder who authorizes use under this License of the Program or a work on which the Program is based. The work thus licensed is called the contributor's &quot;contributor version&quot;. A contributor's &quot;essential patent claims&quot; are all patent claims owned or controlled by the contributor, whether already acquired or hereafter acquired, that would be infringed by some manner, permitted by this License, of making, using, or selling its contributor version, but do not include claims that would be infringed only as a consequence of further modification of the contributor version. For purposes of this definition, &quot;control&quot; includes the right to grant patent sublicenses in a manner consistent with the requirements of this License. Each contributor grants you a non-exclusive, worldwide, royalty-free patent license under the contributor's essential patent claims, to make, use, sell, offer for sale, import and otherwise run, modify and propagate the contents of its contributor version. In the following three paragraphs, a &quot;patent license&quot; is any express agreement or commitment, however denominated, not to enforce a patent (such as an express permission to practice a patent or covenant not to sue for patent infringement). To &quot;grant&quot; such a patent license to a party means to make such an agreement or commitment not to enforce a patent against the party. If you convey a covered work, knowingly relying on a patent license, and the Corresponding Source of the work is not available for anyone to copy, free of charge and under the terms of this License, through a publicly available network server or other readily accessible means, then you must either (1) cause the Corresponding Source to be so available, or (2) arrange to deprive yourself of the benefit of the patent license for this particular work, or (3) arrange, in a manner consistent with the requirements of this License, to extend the patent license to downstream recipients. &quot;Knowingly relying&quot; means you have actual knowledge that, but for the patent license, your conveying the covered work in a country, or your recipient's use of the covered work in a country, would infringe one or more identifiable patents in that country that you have reason to believe are valid. If, pursuant to or in connection with a single transaction or arrangement, you convey, or propagate by procuring conveyance of, a covered work, and grant a patent license to some of the parties receiving the covered work authorizing them to use, propagate, modify or convey a specific copy of the covered work, then the patent license you grant is automatically extended to all recipients of the covered work and works based on it. A patent license is &quot;discriminatory&quot; if it does not include within the scope of its coverage, prohibits the exercise of, or is conditioned on the non-exercise of one or more of the rights that are specifically granted under this License. You may not convey a covered work if you are a party to an arrangement with a third party that is in the business of distributing software, under which you make payment to the third party based on the extent of your activity of conveying the work, and under which the third party grants, to any of the parties who would receive the covered work from you, a discriminatory patent license (a) in connection with copies of the covered work conveyed by you (or copies made from those copies), or (b) primarily for and in connection with specific products or compilations that contain the covered work, unless you entered into that arrangement, or that patent license was granted, prior to 28 March 2007. Nothing in this License shall be construed as excluding or limiting any implied license or other defenses to infringement that may otherwise be available to you under applicable patent law. 12. No Surrender of Others' Freedom. If conditions are imposed on you (whether by court order, agreement or otherwise) that contradict the conditions of this License, they do not excuse you from the conditions of this License. If you cannot convey a covered work so as to satisfy simultaneously your obligations under this License and any other pertinent obligations, then as a consequence you may not convey it at all. For example, if you agree to terms that obligate you to collect a royalty for further conveying from those to whom you convey the Program, the only way you could satisfy both those terms and this License would be to refrain entirely from conveying the Program. 13. Use with the GNU Affero General Public License. Notwithstanding any other provision of this License, you have permission to link or combine any covered work with a work licensed under version 3 of the GNU Affero General Public License into a single combined work, and to convey the resulting work. The terms of this License will continue to apply to the part which is the covered work, but the special requirements of the GNU Affero General Public License, section 13, concerning interaction through a network will apply to the combination as such. 14. Revised Versions of this License. The Free Software Foundation may publish revised and/or new versions of the GNU General Public License from time to time. Such new versions will be similar in spirit to the present version, but may differ in detail to address new problems or concerns. Each version is given a distinguishing version number. If the Program specifies that a certain numbered version of the GNU General Public License &quot;or any later version&quot; applies to it, you have the option of following the terms and conditions either of that numbered version or of any later version published by the Free Software Foundation. If the Program does not specify a version number of the GNU General Public License, you may choose any version ever published by the Free Software Foundation. If the Program specifies that a proxy can decide which future versions of the GNU General Public License can be used, that proxy's public statement of acceptance of a version permanently authorizes you to choose that version for the Program. Later license versions may give you additional or different permissions. However, no additional obligations are imposed on any author or copyright holder as a result of your choosing to follow a later version. 15. Disclaimer of Warranty. THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM &quot;AS IS&quot; WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION. 16. Limitation of Liability. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. 17. Interpretation of Sections 15 and 16. If the disclaimer of warranty and limitation of liability provided above cannot be given local legal effect according to their terms, reviewing courts shall apply local law that most closely approximates an absolute waiver of all civil liability in connection with the Program, unless a warranty or assumption of liability accompanies a copy of the Program in return for a fee. END OF TERMS AND CONDITIONS How to Apply These Terms to Your New Programs If you develop a new program, and you want it to be of the greatest possible use to the public, the best way to achieve this is to make it free software which everyone can redistribute and change under these terms. To do so, attach the following notices to the program. It is safest to attach them to the start of each source file to most effectively state the exclusion of warranty; and each file should have at least the &quot;copyright&quot; line and a pointer to where the full notice is found. &lt;one line to give the program's name and a brief idea of what it does.&gt; Copyright (C) &lt;year&gt; &lt;name of author&gt; This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version. This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received a copy of the GNU General Public License along with this program. If not, see &lt;https://www.gnu.org/licenses/&gt;. Also add information on how to contact you by electronic and paper mail. If the program does terminal interaction, make it output a short notice like this when it starts in an interactive mode: &lt;program&gt; Copyright (C) &lt;year&gt; &lt;name of author&gt; This program comes with ABSOLUTELY NO WARRANTY; for details type `show w'. This is free software, and you are welcome to redistribute it under certain conditions; type `show c' for details. The hypothetical commands `show w' and `show c' should show the appropriate parts of the General Public License. Of course, your program's commands might be different; for a GUI interface, you would use an &quot;about box&quot;. You should also get your employer (if you work as a programmer) or school, if any, to sign a &quot;copyright disclaimer&quot; for the program, if necessary. For more information on this, and how to apply and follow the GNU GPL, see &lt;https://www.gnu.org/licenses/&gt;. The GNU General Public License does not permit incorporating your program into proprietary programs. If your program is a subroutine library, you may consider it more useful to permit linking proprietary applications with the library. If this is what you want to do, use the GNU Lesser General Public License instead of this License. But first, please read &lt;https://www.gnu.org/licenses/why-not-lgpl.html&gt;.","ref":"license.html","title":"License","type":"extras"}]